require "import"
import "android.net.Uri"
import "android.content.Intent"

--从传入参数获取焦点节点
node=...
--获取节点的文字
text=service.getText(node)

--判断是否有内容，没有则退出
if text==nil then
  service.speak("没有发现网址")
  return
  end

function append(t,v)
  if not table.find(t,v) then
    table.insert(t,v)
    end
  end


--创建一个容纳网址的表
ret={}
--循环提取文字中的网址，正则部分以后再说
for url in text:gmatch("https?://[%w%%%=#/%?%._%-%+&]+") do
  --将提取的网址保存在返回表中
  table.insert(ret,url)
  end
for url in text:gmatch("[%w%._%-:/]+%.cn[%w%%%=#/%?%._%-%+&]*") do
  --将提取的网址保存在返回表中
  append(ret,url)
  end
for url in text:gmatch("[%w%._%-:/]+%.com[%w%%%=#/%?%._%-%+&]*") do
  --将提取的网址保存在返回表中
  append(ret,url)
  end
for url in text:gmatch("[%w%._%-:/]+%.org[%w%%%=#/%?%._%-%+&]*") do
  --将提取的网址保存在返回表中
  append(ret,url)
  end
for url in text:gmatch("[%w%._%-:/]+%.net[%w%%%=#/%?%._%-%+&]*") do
  --将提取的网址保存在返回表中
  append(ret,url)
  end


--判断是否有匹配到网址，没有则退出
if #ret==0 then
    service.speak("没有发现网址")
  return
  end
--创建一个对话框显示复制的网址
dlg=service.createDialog("网址",ret).show()

--设置点击后在浏览器打开
dlg.getListView().onItemClick=function(l,v)
  service.startActivity(Intent(Intent.ACTION_VIEW,Uri.parse(v.text)).setFlags(0x10000000))
  dlg.dismiss()
  end
